package org.artifactory.ph;

import org.artifactory.common.resource.BaseResource;
import com.jfrog.ph.acl.exception.PackageVirtualTraversalException;
import com.jfrog.ph.acl.virtual.resolution.PackageMetadataRow;
import com.jfrog.ph.acl.virtual.resolution.PackageRepo;
import com.jfrog.ph.acl.virtual.resolution.PackageRequestContext;
import com.jfrog.ph.acl.virtual.resolution.PackageVirtualController;

public interface PackageVirtualResolutionService<T extends PackageMetadataRow> extends PackageVirtualController<T> {
    /**
     * The method allows deciding whether to use the legacy virtual resolution strategy;
     *
     * @param virtualRepoKey The virtual repository key
     * @return True in case that the package support the new virtual resolution framework
     */
    boolean shouldUsePackageVirtualResolution(String virtualRepoKey);

    /**
     * Used  by Artifactory to get item resolution by the package layer
     *
     * @param virtualRepo the virtual repository key
     * @param context     request context
     * @return Item Info
     */
    BaseResource getItemInfoFromVirtual(PackageRepo virtualRepo, PackageRequestContext context) throws
            PackageVirtualTraversalException;
}
