package org.artifactory.storage.service;

import org.artifactory.storage.binstore.service.ArtifactoryBinaryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.concurrent.atomic.AtomicReference;

@Service
public class StorageMetricCollectorImpl implements StorageMetricCollector {

    private final AtomicReference<StorageMetric> storageMetric =
            new AtomicReference<>(new StorageMetric(0));

    private final ArtifactoryBinaryService binaryService;

    @Autowired
    public StorageMetricCollectorImpl(ArtifactoryBinaryService binaryService) {
        this.binaryService = binaryService;
    }

    @Override
    public void update() {
        long storageSize = binaryService.getStorageSize();
        storageMetric.set(new StorageMetric(storageSize));
    }

    @Override
    public StorageMetric get() {
        return storageMetric.get();
    }

}
