package org.artifactory.repo.cache.expirable;

import org.testng.annotations.DataProvider;
import org.testng.annotations.Test;

import static org.testng.AssertJUnit.assertEquals;

public class InternalMetadataCheckerTest {

    @Test(dataProvider = "pathExamples")
    public void testPath(String path, boolean isInternal) {
        assertEquals(isInternal, InternalMetadataChecker.isInternalMetadata(path));
    }

    @DataProvider
    public static Object[][] pathExamples() {
        return new Object[][] {
                { "", false },
                { " ", false },
                { ".", false },
                { "normal.file", false },
                { "יוניקוד.xls", false },
                { ".jfrog", true },
                { ".jfrog/index", true }
        };
    }
}
