package org.artifactory.logging;

import ch.qos.logback.classic.Level;
import ch.qos.logback.classic.Logger;
import ch.qos.logback.classic.spi.LoggingEvent;
import io.vavr.collection.Array;
import org.slf4j.LoggerFactory;

import java.time.Instant;
import java.util.Map;

public class LoggingTestUtils {
    public static LoggingEvent createEvent(Array argumentArray, Class clazz) {
        Logger logger = (ch.qos.logback.classic.Logger) LoggerFactory.getLogger(clazz);
        LoggingEvent event = new LoggingEvent("fqcn", logger, Level.INFO, "", null,
                argumentArray.toJavaArray());
        event.setTimeStamp(Instant.ofEpochMilli(System.currentTimeMillis()).toEpochMilli());
        event.setMDCPropertyMap(Map.of("uber-trace-id", "traceid"));
        return event;
    }
}
