package org.artifactory.repo;

import org.apache.commons.lang.StringUtils;
import org.artifactory.descriptor.repo.FederatedRepoDescriptor;
import org.artifactory.descriptor.repo.ProxyDescriptor;
import org.artifactory.descriptor.repo.RepoType;
import org.artifactory.model.FederatedRepoConfig;
import org.testng.annotations.Test;

import static org.testng.Assert.assertEquals;
import static org.testng.Assert.assertTrue;

/**
 * @author Alexei Vainshtein
 */
public class FederatedRepositoryConfigurationImplTest {

    @Test
    public void testDefaultType() {
        FederatedRepoConfig federatedRepoConfig = FederatedRepoConfig.create("repoKey", RepoType.Generic);
        FederatedRepositoryConfiguration configuration =
                new FederatedRepositoryConfigurationImpl(federatedRepoConfig);
        assertEquals(configuration.getType(), FederatedRepositoryConfigurationImpl.TYPE);
        assertTrue(StringUtils.isBlank(configuration.getProxy()));
    }

    @Test
    public void testAddingProxy() {
        FederatedRepoDescriptor federatedRepoDescriptor = new FederatedRepoDescriptor();
        federatedRepoDescriptor.setProxy(new ProxyDescriptor());
        FederatedRepoConfig federatedRepoConfig = FederatedRepoConfig.create("repoKey", RepoType.Generic);
        federatedRepoConfig.getRepoTypeConfig().setProxyRef("key");
        FederatedRepositoryConfigurationImpl configuration =
                new FederatedRepositoryConfigurationImpl(federatedRepoConfig);
        assertEquals(configuration.getType(), FederatedRepositoryConfigurationImpl.TYPE);
        assertEquals(configuration.getProxy(), "key");

        configuration.setProxy("newKey");
        assertEquals(configuration.getProxy(), "newKey");
    }
}