package org.artifactory.repo.packagetype.configuration;

import lombok.Data;
import org.artifactory.common.config.metadata.MetadataInfo;
import org.artifactory.common.config.metadata.MetadataVersion;
import org.artifactory.repo.packagetype.ExternalDependenciesConfig;

/**
 * @author Tamar Rosen
 */
@Data
@MetadataVersion(metadataVersion = 1)
public class CocoaPodsConfiguration {
    @MetadataInfo(defaultValue = "0")
    private long modelVersion;
    @MetadataInfo(skip = true)
    private ExternalDependenciesConfig externalDependencies;
    @MetadataInfo(skip = true)
    private String cocoaPodsSpecsRepoUrl = "https://github.com/CocoaPods/Specs";
    @MetadataInfo(skip = true)
    private VcsGitConfiguration specRepoProvider = new VcsGitConfiguration();
    @MetadataInfo(skip = true)
    private VcsConfiguration vcs;
}
