package org.artifactory.model.xstream.security;

import org.artifactory.security.MutableReleaseBundlePermissionTarget;
import org.artifactory.security.ReleaseBundlePermissionTarget;

import javax.xml.bind.annotation.XmlRootElement;
import java.util.ArrayList;

/**
 * @author Inbar Tal
 */
@XmlRootElement(name = "target")
public class ReleaseBundlePermissionTargetImpl extends RepoPermissionTargetImpl implements
        MutableReleaseBundlePermissionTarget {

    public ReleaseBundlePermissionTargetImpl() {
        this("");
    }

    public ReleaseBundlePermissionTargetImpl(String name) {
        super(name, new ArrayList<>(), new ArrayList<>());
    }

    public ReleaseBundlePermissionTargetImpl(ReleaseBundlePermissionTarget copy) {
        super(copy.getName(),
                new ArrayList<>(copy.getRepoKeys()),
                new ArrayList<>(copy.getIncludes()),
                new ArrayList<>(copy.getExcludes())
        );
    }
}
