package org.artifactory.storage.db.hqc.entity;

import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.assertEquals;

/**
 * @author Tomer Slutsky
 * @author Andrey Tashlitsky
 */
class HeavyQueryCacheEntryTest {

    @Test
    void testToString() {
        HeavyQueryCacheEntry hqcEntry = HeavyQueryCacheEntry.builder()
                .id(1)
                .cacheKey("cool-key")
                .cacheTime(100)
                .expiryTime(110)
                .data("cool-data".getBytes())
                .build();
        assertEquals(1, hqcEntry.getId());
        assertEquals("cool-key", hqcEntry.getCacheKey());
        assertEquals(100, hqcEntry.getCacheTime());
        assertEquals(110, hqcEntry.getExpiryTime());
        assertEquals("cool-data", new String(hqcEntry.getData()));
        assertEquals("HeavyQueryCacheEntry(id=1, cacheKey=cool-key, cacheTime=100, expiryTime=110)",
                hqcEntry.toString());
    }
}
