package org.artifactory.storage.db.upgrades.itest.version;

import org.artifactory.storage.db.upgrades.common.AsyncUpgradeBaseTest;
import org.artifactory.storage.db.version.ArtifactoryDBVersion;
import org.jfrog.storage.DbType;

import java.sql.SQLException;

import static org.artifactory.storage.db.version.ArtifactoryDBVersion.v157;
import static org.jfrog.storage.util.DbUtils.extensionExists;
import static org.testng.Assert.assertTrue;

/**
 * @author Hussein Alshqerat
 */
public class V157CreatePgtrgmExtensionTest extends AsyncUpgradeBaseTest {
    public void testExtensionExists() throws SQLException {
        testOnlyWithPostgresql();
        assertTrue(extensionExists(jdbcHelper, DbType.POSTGRESQL, "pg_trgm"));
    }

    @Override
    protected ArtifactoryDBVersion upToVersion() {
        return v157;
    }
}
